//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DNodeEnumerator
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Wed Nov 24 10:13:29 CET 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DNodeEnumerator.m,v 1.3 2001/01/05 20:50:53 robert Exp $
//-----------------------------------------------------------------------------

#import <RenderKit/G3DNodeEnumerator.h>

#import <RenderKit/G3DNodeList.h>

@implementation G3DNodeEnumerator

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DNodeEnumerator *)nodeEnumeratorWithList:(G3DNodeList *)alist startIndex:(unsigned int)startIndex stopIndex:(unsigned int)stop
{
  return [[[G3DNodeEnumerator alloc] initWithList:alist startIndex:startIndex stopIndex:stop] autorelease];
}

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithList:(G3DNodeList *)alist startIndex:(unsigned int)startIndex stopIndex:(unsigned int)stop
{
  if ((self = [super init])) {
    position = startIndex;
    endPosition = stop;
    list = [alist retain];
  }
  return self;
}

- (void)dealloc
{
  [list release];

  [super dealloc];
}

//-----------------------------------------------------------------------------
// Accessors
//-----------------------------------------------------------------------------

- (NSArray *)allObjects
{
  NSMutableArray *data = [NSMutableArray array];

  while (position < endPosition) {
    id _obj = [list nodeAtIndex:position++];

    if (_obj) {
      [data addObject:_obj];
    }
  }
  
  return (NSArray *)data;
}

- (id)nextObject
{
  id _obj = nil;
  
  if (position < endPosition) {
    _obj = [list nodeAtIndex:position++];
  }
  return _obj;
}

- (BOOL)containsMoreObjects
{
  return (position < endPosition);
}

@end






