//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DRotator
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Fri Apr 28 08:37:15 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DRotator.m,v 1.7 2001/07/15 13:55:43 probert Exp $
//-----------------------------------------------------------------------------

#import "G3DRotator.h"
#import "G3DTransform.h"
#import "G3DCamera.h"

@implementation G3DRotator

//-----------------------------------------------------------------------------
// Init and free
//-----------------------------------------------------------------------------

- (id)initWithCamera:(G3DCamera*)aCamera
{
  if ((self = [super init])) {
    camera = [aCamera retain];
  }
  return self;
}

- (void)dealloc
{
  [camera release];

  [super dealloc];
}

//-----------------------------------------------------------------------------
// Accessor methods
//-----------------------------------------------------------------------------

- (void)setCenter:(NSPoint)center radius:(float)radius
{
  _center = center;
  _radius = radius;
}

- (void)setRotationAxis:(G3D_Axis)anAxis
{
  axis = anAxis;
}

- (G3D_Axis)rotationAxis
{
  return axis;
}

//-----------------------------------------------------------------------------
// Rotating
//-----------------------------------------------------------------------------

- (void)trackMouseFrom:(const NSPoint *)from to:(const NSPoint *)to rotation:(G3DTransform **)rotation
{
#warning trackMouseFrom:to:rotation: not yet implemented!
}

@end






