//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DShape+Surface
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Fri Jun 16 13:50:36 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DShape+Surface.m,v 1.5 2001/01/05 20:50:54 robert Exp $
//-----------------------------------------------------------------------------

#import "G3DShape+Surface.h"
#import "G3DSurface.h"

@implementation G3DShape (Surface)

+ (G3DShape *)surfaceWithScale:(float)sc colour:(G3DColour *)col texture:(G3DTexture *)tex
{
  id shape;
  
  if ((shape = [[G3DShape alloc] initWithTexture:tex geometry:nil])) {
    id geom;

    geom = [G3DSurface surfaceWithScale:sc];
    [shape setBVolType:G3D_AABB];
    [shape setGeometry:geom];
    [geom setColour:col];

    [shape updateBVolume];
  }
  return [shape autorelease];
}

@end
