/* 
   GlutDemo.m

   Simple encoding/decoding demo based on rk's archiving classes

   Copyright (C) 2000 Philippe C.D. Robert

   Author:  Philippe C.D. Robert <phr@3dkit.org>
   Date: March 2000
   
   This file is part of the interactive 3DKit

   This file is rleased under the GNU GPL!
*/ 

#import <Foundation/Foundation.h>

#import <RenderKit/RenderKit.h>
#import <GeometryKit/GeometryKit.h>

@interface AppController : NSObject
{
}

- (void)applicationDidFinishLaunching;

@end

@implementation AppController

- (void)applicationDidFinishLaunching
{
  G3DSphere *sph = [G3DSphere sphereWithX:3.1 y:1.9 z:2.0 radius:0.75];
  G3DTuple2d *tuple = [G3DTuple2d tuple2dWithX:5.0 y:2.9];
  G3DVector3d *vec = [G3DVector3d vector3dWithX:2.11 y:2.0 z:-8.3];
  G3DVector *vec2 = [G3DVector vectorWithSize:13];
  G3DMatrix4d *mat = [G3DMatrix4d matrix4d];
  NSString *string = [NSString stringWithString:@"TestStringIn1"];
  NSArray *array1 = [NSArray arrayWithObjects:string,@"AnotherStringIn1",tuple,nil];
  NSArray *array2 = [NSArray arrayWithObjects:array1,vec,mat,vec2,sph,@"StringIn2",nil];
  NSString *file = @"encoding.test";
  id decoded;

  NSLog(@"Encoding array....");
  if(![G3DArchiver archiveObjectTree:array2 toFile:file]) {
    NSLog(@"Couldn't encode to file %@",file);
  }
  NSLog(@"...done!");

  NSLog(@"Decoding array....");
  if(!(decoded = [G3DUnarchiver unarchiveObjectTreeWithContentsOfFile:file])) {
    NSLog(@"Couldn't decode from file %@",file);
  }
  else {
    NSLog(@"Decoded objecttree %@",[decoded description]);
  }
  NSLog(@"...done!");
}

@end

int main(int argc, char **argv)
{
  AppController *controller;
  id pool = [NSAutoreleasePool new];

  // The delegate
  controller = [[AppController alloc] init];
  [controller applicationDidFinishLaunching];

  // The end...
  [controller release];
  [pool release];

  return 0;
}



