/* 
 * G3DGLXCamera.h created by probert on 2001-07-20 20:42:59 +0000
 *
 * Project GLXKit
 *
 * Created with ProjectCenter - http://www.projectcenter.ch
 *
 * $Id: G3DGLXCamera.h,v 1.3 2001/07/22 11:58:25 probert Exp $
 */

#ifndef __G3DGLXCamera_h_INCLUDE
#define __G3DGLXCamera_h_INCLUDE

#import <Foundation/Foundation.h>
#import <RenderKit/G3DCamera.h>

#include <GL/glx.h>

@interface G3DGLXCamera : G3DCamera
{
    Display  *display;
    int       screen;
    Window    window;
    NSString *title;
    NSString *icnName;

@private

    GLXContext   ctx;
    XVisualInfo *vinfo;
    NSString    *error;
    Cursor       nullCursor;
    Atom         wmDeleteAtom;
    int          flags;

    enum eFlags
    {
	kOpenedDisplay = 0x0001,
    };
}

//-----------------------------------------------------------------------------
// Init methods
//-----------------------------------------------------------------------------

- (id)initWithSize:(NSSize)aSize;
- (id)initWithSize:(NSSize)aSize input:(long)mask source:(int)src display:(Display *)dpy;

//-----------------------------------------------------------------------------
// X11 methods
//-----------------------------------------------------------------------------

- (Display *)display;
- (int)screen;
- (Window)window;

- (int)displayWidth;
- (int)displayHeight;

- (void)setFrame:(NSRect)aFrame display:(BOOL)yn;

- (NSString *)title;
- (void)setTitle:(NSString *)aTitle;

- (NSString *)miniwindowTitle;
- (void)setMiniwindowTitle:(NSString *)aTitle;

- (void)raise;

- (void)show;
- (void)hide;
- (BOOL)isVisible;

- (void)iconify;
- (void)unIconify;

- (void)flushWindow;
- (void)syncWindow:(BOOL)discard;

- (void)hideCursor;
- (void)showCursor;


//-----------------------------------------------------------------------------
// GLX methods
//-----------------------------------------------------------------------------

- (GLXContext)context;
- (XVisualInfo*)visual;

- (void)makeCurrent;
- (void)swapBuffers;

//-----------------------------------------------------------------------------
// Dummy implementations - need subclassing!
//-----------------------------------------------------------------------------

- (void)unknownEvent:(XEvent*)event;
- (void)deleteEvent:(XEvent*)event;
- (void)configureEvent:(XConfigureEvent*)event;
- (void)buttonDown:(XButtonEvent*)event;
- (void)buttonUp:(XButtonEvent*)event;
- (void)motionEvent:(XMotionEvent*)event;
- (void)keyDown:(XKeyEvent*)event;
- (void)keyUp:(XKeyEvent*)event;
- (void)focusIn:(XFocusChangeEvent*)event;
- (void)focusOut:(XFocusChangeEvent*)event;
- (void)exposeEvent:(XExposeEvent*)event;

//-----------------------------------------------------------------------------
// X11 error stuff
//-----------------------------------------------------------------------------

- (NSString *)errorDescription;

@end

extern NSString *G3DGLXCameraException;

#endif
